<%@page import="java.util.Map"%>
<%@page import="java.util.HashMap"%>
<%@page import="java.util.List"%>
<%@page import="java.util.Collections"%>
<%@page import="java.util.Comparator"%>
<%@page import="java.util.ArrayList"%>
<%@ page import="java.text.SimpleDateFormat" %>
<%@ page import="java.io.IOException" %>
<%@ page import="java.net.URLDecoder" %>
<%@ page import="org.slf4j.Logger" %>
<%@ page import="org.slf4j.LoggerFactory" %>
<%@ page import="com.openkm.bean.Document" %>
<%@ page import="com.openkm.util.WebUtils" %>
<%@ page import="com.openkm.core.Config" %>
<%@ page import="com.openkm.principal.DatabasePrincipalAdapter" %>
<%@ page import="com.openkm.dao.bean.User" %>
<%@ page import="com.openkm.dao.AuthDAO" %>
<%@ page import="com.openkm.api.OKMAuth" %>
<%@ page import="com.openkm.api.OKMRepository" %>
<%@ page import="com.openkm.api.OKMDocument" %>
<%@ page extends="com.openkm.extension.servlet.BaseServlet" %>
<%@ page language="java" contentType="text/html; charset=UTF-8" pageEncoding="UTF-8" %>
<%!private static Logger log = LoggerFactory.getLogger("com.openkm.sample");
	private static SimpleDateFormat df = new SimpleDateFormat("dd/MM/yyyy HH:mm:ss");
	private static boolean db = Config.PRINCIPAL_ADAPTER.equals(DatabasePrincipalAdapter.class.getCanonicalName());
	
	public void doGet(HttpServletRequest request, HttpServletResponse response) throws IOException,
			ServletException {
		String action = WebUtils.getString(request, "action");		
		try {
          // Something to do here with action  
			list(request, response);
		} catch (Exception e) {
			log.error(e.getMessage(), e);
			sendErrorRedirect(request, response, e);
		}
	}

	// Used by fileupload return
	public void doPost(HttpServletRequest request, HttpServletResponse response) throws IOException,
	ServletException {
		String action = WebUtils.getString(request, "action");
		try {
			if (action.equals("filter")) {
				list(request, response);
			}
		} catch (Exception e) {
			log.error(e.getMessage(), e);
			sendErrorRedirect(request, response, e);
		}
	}
	
	private void list(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException, Exception {		
		String nameFilter = WebUtils.getString(request,"nameFilter");
		String userFilter = WebUtils.getString(request,"userFilter");

		// Getting lists
		List<Map<String,String>> leftDocsMaps = leftList(""); // Pending documents for all users
		List<Map<String,String>> rightDocsMaps = rightList("");
		List<Map<String,String>> leftDownDocsMaps = leftDownList("");
		List<Map<String,String>> rightDownDocsMaps = rightDownList("");
		
		List<String> users = new ArrayList<String>();
		// UserList
		if (db) {
			for(User user : AuthDAO.findAllUsers(false)) {
				users.add(user.getId());
			}
		} else {
			users = OKMAuth.getInstance().getUsers(null);
		}

		ServletContext sc = getServletContext();
		sc.setAttribute("nameFilter",nameFilter);
		sc.setAttribute("leftDocsMaps",leftDocsMaps);
		sc.setAttribute("rightDocsMaps",rightDocsMaps);
		sc.setAttribute("leftDownDocsMaps",leftDownDocsMaps);
		sc.setAttribute("rightDownDocsMaps",rightDownDocsMaps);
		sc.setAttribute("users", users);
		sc.setAttribute("nameFilter", nameFilter);
		sc.setAttribute("userFilter", userFilter);
		sc.getRequestDispatcher("/totem/sample1/distributor.jsp").forward(request, response);
	}

	public Comparator<Map<String, String>> mapComparator = new Comparator<Map<String, String>>() {
		public int compare(Map<String, String> m1, Map<String, String> m2) {
			return m2.get("lastModified").compareTo(m1.get("lastModified"));
		}
	};
//LISTA 1
	private List<Map<String,String>> leftList(String user) throws Exception {
		List<Map<String,String>> documentsMap = new ArrayList<Map<String,String>>();
        // To change
        List<Document> pendingDocuments = new ArrayList<Document>();
		for (Document doc : OKMDocument.getInstance().getChildren(null, "/okm:root/CarpetaPrueba1")) {
			Map<String,String> docMap = new HashMap<String,String>();
			docMap.put("author",doc.getAuthor());
			docMap.put("name",doc.getPath().substring(doc.getPath().lastIndexOf("/")+1));
			docMap.put("uuid",doc.getUuid());
			docMap.put("path",doc.getPath());
			docMap.put("mimeType",doc.getMimeType());
			docMap.put("lastModified", df.format(doc.getLastModified().getTime()));
			documentsMap.add(docMap);
		}		
		Collections.sort(documentsMap,mapComparator);
		return documentsMap;
	}
//LISTA 2
	private List<Map<String,String>> rightList(String user) throws Exception {
                List<Map<String,String>> documentsMap = new ArrayList<Map<String,String>>();
        // To change
        List<Document> pendingDocuments = new ArrayList<Document>();
                for (Document doc : OKMDocument.getInstance().getChildren(null, "/okm:root/Carpeta")) {
                        Map<String,String> docMap = new HashMap<String,String>();
                        docMap.put("author",doc.getAuthor());
                        docMap.put("name",doc.getPath().substring(doc.getPath().lastIndexOf("/")+1));
                        docMap.put("uuid",doc.getUuid());
                        docMap.put("path",doc.getPath());
                        docMap.put("mimeType",doc.getMimeType());
                        docMap.put("lastModified", df.format(doc.getLastModified().getTime()));
                        documentsMap.add(docMap);
                }
                Collections.sort(documentsMap,mapComparator);
                return documentsMap;
        }

//LISTA 3
        private List<Map<String,String>> leftDownList(String user) throws Exception {
                List<Map<String,String>> documentsMap = new ArrayList<Map<String,String>>();
        // To change
        List<Document> pendingDocuments = new ArrayList<Document>();
                for (Document doc : OKMDocument.getInstance().getChildren(null, "/okm:root/")) {
                        Map<String,String> docMap = new HashMap<String,String>();
                        docMap.put("author",doc.getAuthor());
                        docMap.put("name",doc.getPath().substring(doc.getPath().lastIndexOf("/")+1));
                        docMap.put("uuid",doc.getUuid());
                        docMap.put("path",doc.getPath());
                        docMap.put("mimeType",doc.getMimeType());
                        docMap.put("lastModified", df.format(doc.getLastModified().getTime()));
                        documentsMap.add(docMap);
                }
                Collections.sort(documentsMap,mapComparator);
                return documentsMap;
        }

//LISTA 4
        private List<Map<String,String>> rightDownList(String user) throws Exception {
                List<Map<String,String>> documentsMap = new ArrayList<Map<String,String>>();
        // To change
        List<Document> pendingDocuments = new ArrayList<Document>();
                for (Document doc : OKMDocument.getInstance().getChildren(null, "/okm:root/Prueba/")) {
                        Map<String,String> docMap = new HashMap<String,String>();
                        docMap.put("author",doc.getAuthor());
                        docMap.put("name",doc.getPath().substring(doc.getPath().lastIndexOf("/")+1));
                        docMap.put("uuid",doc.getUuid());
                        docMap.put("path",doc.getPath());
                        docMap.put("mimeType",doc.getMimeType());
                        docMap.put("lastModified", df.format(doc.getLastModified().getTime()));
                        documentsMap.add(docMap);
                }
                Collections.sort(documentsMap,mapComparator);
                return documentsMap;
        }

























//	private List<Map<String,String>> rrightList(String user, String nameFilter) throws Exception {
//		List<Map<String,String>> documentsMap = new ArrayList<Map<String,String>>();
//		for (Document doc : OKMDocument.getInstance().getChildren(null, "/okm:root/Carpeta Prueba1")) {
//          boolean found = true;
//            if (!user.equals("") && !user.equals(doc.getAuthor())) {
//               found = false;
//            }
//            if (!nameFilter.equals("") && !doc.getPath().contains(nameFilter)) {
//		found = false;
//            }  
//           
//            if (found) {
//			Map<String,String> docMap = new HashMap<String,String>();
//			docMap.put("author",doc.getAuthor());
//			docMap.put("name",doc.getPath().substring(doc.getPath().lastIndexOf("/")+1));
//			docMap.put("uuid",doc.getUuid());
//			docMap.put("path",doc.getPath());
//			docMap.put("mimeType",doc.getMimeType());
//			docMap.put("lastModified", df.format(doc.getLastModified().getTime()));
//			documentsMap.add(docMap);
  //          }
//		} 
//		return documentsMap;
//	}

  %>
